<?php
namespace Indeed\Ihc\PaymentGateways;
/*
@since 7.4
*/

class Mellat extends \Indeed\Ihc\PaymentGateways\PaymentAbstract
{

  protected $attributes       = array();
  protected $redirectUrl      = '';
  protected $abort            = false;
  protected $paymentTypeLabel = 'Mellat Payment';
  protected $currency         = '';
 
    public function __construct()
    {
        $this->currency = get_option('ihc_currency');
        include "nusoap.php";
    }

  	public function doPayment(){
      \Ihc_User_Logs::set_user_id(@$this->attributes['uid']);
      \Ihc_User_Logs::set_level_id(@$this->attributes['lid']);
      \Ihc_User_Logs::write_log( __('mellat Payment: Start process', 'ihc'), 'payments');
      $levels = get_option('ihc_levels');
      $sandbox = get_option('ihc_mellat_sandbox');
      $r_url = get_option('ihc_mellat_return_page');

      if(!$r_url || $r_url==-1){
        $r_url = get_option('page_on_front');
      }
      $r_url = get_permalink($r_url);
      if (!$r_url){
        $r_url = get_home_url();
      }
      
      $err = false;
      if (isset($levels[$this->attributes['lid']])){
        $level_arr = $levels[$this->attributes['lid']];
        if ($level_arr['payment_type']=='free' || $level_arr['price']=='') $err = true;
      } else {
        \Ihc_User_Logs::write_log( __('mellat Payment: Level is free, no payment required.', 'ihc'), 'payments');
        $err = true;
      }
      // USER ID
      if (!empty($this->attributes['uid'])){
        $uid = $this->attributes['uid'];
      } else {
        $uid = get_current_user_id();
      }
      if (!$uid){
        $err = true;
        \Ihc_User_Logs::write_log( __('mellat Payment: Error, user id not set.', 'ihc'), 'payments');
      } else {
        \Ihc_User_Logs::write_log( __('mellat Payment: set user id @ ', 'ihc') . $uid, 'payments');
      }

      /// dynamic price
      $level_arr['price'] = $this->applyDynamicPrice($level_arr['price']);

      if ($err){
        ////if level it's not available for some reason, go back to prev page
        \Ihc_User_Logs::write_log( __('mellat Payment: stop process, redirect home.', 'ihc'), 'payments');
        //header( 'location:'. $r_url );
        //exit();
      } else {
        $custom_data = json_encode(array('user_id' => $uid, 'level_id' => $this->attributes['lid'] ));
      }

      $site_url = site_url();
      $site_url = trailingslashit($site_url);
      $notify_url = add_query_arg('ihc_action', 'mellat', $site_url);

      \Ihc_User_Logs::write_log( __('mellat Payment: set ipn url @ ', 'ihc') . $notify_url, 'payments');

      $reccurrence = FALSE;
      if (isset($level_arr['access_type']) && $level_arr['access_type']=='regular_period'){
        $reccurrence = TRUE;
        \Ihc_User_Logs::write_log( __('mellat Payment: Recurrence payment set.', 'ihc'), 'payments');
      }

      //coupons
      $coupon_data = array();
      if (!empty($this->attributes['ihc_coupon'])){
        $coupon_data = ihc_check_coupon($this->attributes['ihc_coupon'], $this->attributes['lid'] );
        \Ihc_User_Logs::write_log( __('PayPal Payment: the user used the following coupon: ', 'ihc') . $this->attributes['ihc_coupon'], 'payments');
      }
      
      update_option('Status_zal','lll');
      $reccurrence = TRUE;
      if ($reccurrence){
          update_option('Statjus_zal','lll');
        //====================RECCURENCE
        //coupon on reccurence
        if ($coupon_data){
          if (!empty($coupon_data['reccuring'])){
            //everytime the price will be reduced
            $level_arr['price'] = ihc_coupon_return_price_after_decrease($level_arr['price'], $coupon_data, TRUE, $this->attributes['uid'], $this->attributes['lid']);
            if (isset($level_arr['access_trial_price'])){
              $level_arr['access_trial_price'] = ihc_coupon_return_price_after_decrease($level_arr['access_trial_price'], $coupon_data, FALSE);
            }
          } else {
            //only one time
            if (!empty($level_arr['access_trial_price'])){
              $level_arr['access_trial_price'] = ihc_coupon_return_price_after_decrease($level_arr['access_trial_price'], $coupon_data, TRUE, $uid, $this->attributes['lid']);
            } else {
              $level_arr['access_trial_price'] = ihc_coupon_return_price_after_decrease($level_arr['price'], $coupon_data, TRUE, $uid, $this->attributes['lid']);
              $level_arr['access_trial_type'] = 2;
            }
            if (empty($level_arr['access_trial_type'])){
              $level_arr['access_trial_type'] = 2;
            }
          }
        }

        if ($coupon_data){
          $level_arr['price'] = ihc_coupon_return_price_after_decrease($level_arr['price'], $coupon_data, TRUE, $uid, $this->attributes['lid']);
        }
      
      if (ihc_is_magic_feat_active('level_dynamic_price') && isset($this->attributes['ihc_dynamic_price'])){
              $temp_amount = $this->attributes['ihc_dynamic_price'];
              if (ihc_check_dynamic_price_from_user($this->attributes['lid'], $temp_amount)){
                  $amount = $temp_amount;
                  \Ihc_User_Logs::write_log( $this->paymentTypeLabel . __(': Dynamic price on - Amount is set by the user @ ', 'ihc') . $amount . $this->currency, 'payments');
              }
       }
          /**************************** DYNAMIC PRICE ***************************/

        //  $amount = number_format( (float)$amount, 2, '.', '' );
       
      $transactionData = array(
        'lid'                 => $this->attributes['lid'],
        'uid'                 => $this->attributes['uid'],
        'ihc_payment_type'    => 'mellat',
        'amount'              => $level_arr['price'],
        'message'             => 'pending',
        'currency'            => $this->currency,
        'item_name'           => $level_arr['name'],
      );
	  global $current_user;
	  
	  $mellat_email = get_option('ihc_mellat_email');
  	  $mellat_userName = get_option('ihc_mellat_userName');
      $mellat_userPassword = get_option('ihc_mellat_userPassword');
      
	  $orderId		= time();						// Order ID
      $localDate		= date('Ymd');					// Date
      $localTime		= date('Gis');					// Time
      $additionalData	= '';
      $payerId		= '0';
      
	  $parameters = array(
	    'terminalId' 		=> $mellat_email,
	    'userName' 			=> $mellat_userName,
	    'userPassword' 		=> $mellat_userPassword,
	    'orderId' 			=> $orderId,
	    'amount' 			=> urlencode($level_arr['price']),
	    'localDate' 		=> $localDate,
	    'localTime' 		=> $localTime,
	    'additionalData' 	=> $additionalData,
	    'callBackUrl' 		=> $r_url,
	    'payerId' 			=> $payerId
	);
	$client = new \nusoap_client('https://bpm.shaparak.ir/pgwchannel/services/pgw?wsdl');
	$namespace='http://interfaces.core.sw.bps.com/';
	
	$result = $client->call('bpPayRequest', $parameters, $namespace);
	//$result = $client->call('bpPayRequest', $parameters , $namespace);
	
    //-- بررسی وجود خطا
    if ($client->fault){
	  //-- نمایش خطا
	  echo "There was a problem connecting to Bank";
	  exit;
    }else{
	  $err = $client->getError();
	  if ($err){
		//-- نمایش خطا
		echo "Error : ". $err;
		exit;
	  }else{
	    $res 		= explode (',',$result);
		$ResCode 	= $res[0];
		
		if ($ResCode == "0")
		{
		    update_option('is_payment_mellat','1');
			update_option( 'mellat'.$_GET['uid'], 'mellat' );
            update_option( 'price'.$_GET['uid'], $level_arr['price'] );
            update_option( 'lid'.$_GET['uid'], $_GET['lid'] );
            $r_url = get_option('ihc_mellat_return_page');
            update_option( 'r_url'.$_GET['uid'], $r_url );
		    update_option( 'mellat'.$this->attributes['uid'], 'mellat' );
            update_option( 'price'.$this->attributes['uid'], $level_arr['price'] );
            update_option( 'lid'.$this->attributes['uid'], $this->attributes['lid'] );
            $r_url = get_option('ihc_mellat_return_page');
            update_option( 'r_url'.$this->attributes['uid'], $r_url );
	        ihc_insert_update_transaction( $this->attributes['uid'], $paymentId, $transactionData, true ); /// will save the order too
            \Ihc_Db::updateTransactionAddOrderId( $paymentId, @$this->attributes['orderId'] );
			//-- انتقال به درگاه پرداخت
			$this->redirectUrl = '<form name="myform" action="https://bpm.shaparak.ir/pgwchannel/startpay.mellat" method="POST">
					<input type="hidden" id="RefId" name="RefId" value="'. $res[1] .'">
				</form>
				<script type="text/javascript">window.onload = formSubmit; function formSubmit() { document.forms[0].submit(); }</script>';
			return $this;
		}
		else
		{
			//-- نمایش خطا
			echo "Error : ". $result;
			return $this;
		}
	  }
    }
      }
      
      return $this;
    }

  	public function redirect()
    {
        \Ihc_User_Logs::write_log( __('PayPal Payment: Request submited.', 'ihc'), 'payments');
        echo $this->redirectUrl;
        //header( 'location:' . $this->redirectUrl);
        exit();
    }

    public function webhook()
    {
	  $mellat_email = get_option('ihc_mellat_email');
      $mellat_userName = get_option('ihc_mellat_userName');
      $mellat_userPassword = get_option('ihc_mellat_userPassword');
      ini_set('display_errors','on');

      if (get_option('ihc_debug_payments_db')){
        ihc_insert_debug_payment_log('mellat', $_POST);
      }

      \Ihc_User_Logs::write_log( __('PayPal Payment IPN: Start process', 'ihc'), 'payments');
      if ($_POST['ResCode'] == '0') {
          $client = new \nusoap_client('https://pgwstest.bpm.bankmellat.ir/pgwchannel/services/pgw?wsdl');
          $namespace = 'http://interfaces.core.sw.bps.com/';
 				
	      $orderId 				= $_POST['SaleOrderId'];		// Order ID
	
	      $verifySaleOrderId 		= $_POST['SaleOrderId'];
	      $verifySaleReferenceId 	= $_POST['SaleReferenceId'];
		  
	      $parameters = array(
		    'terminalId' => $mellat_email,
		    'userName' => $mellat_userName,
		    'userPassword' => $mellat_userPassword,
		    'orderId' => $orderId,
		    'saleOrderId' => $verifySaleOrderId,
		    'saleReferenceId' => $verifySaleReferenceId);
	      // Call the SOAP method
	      $result = $client->call('bpVerifyRequest', $parameters, $namespace);
          if($result == '0') {
		    //-- وریفای به درستی انجام شد٬ درخواست واریز وجه
		    // Call the SOAP method
		    $result = $client->call('bpSettleRequest', $parameters, $namespace);
		    if($result == '0') {
			  //-- تمام مراحل پرداخت به درستی انجام شد.
			  //-- آماده کردن خروجی
			  $Status = 'completed';
              $Transaction_ID = $result['RefID'];
       
			  $lid = get_option('lid'.get_current_user_id());
	    	  $level_data = ihc_get_level_by_id($lid);
              update_option( 'lid', $lid );
			  ihc_set_level_trial_time_for_no_pay($level_data, $lid);
              \Ihc_User_Logs::write_log( __("mellat Payment IPN: Update user level expire time (Trial).", 'ihc'), 'payments');
              ihc_send_user_notifications($lid, 'payment', $lid);//send notification to user
              ihc_send_user_notifications($lid, 'admin_user_payment', $lid);//send notification to admin
              do_action( 'ihc_payment_completed', $lid, $lid );
              ihc_switch_role_for_user($lid);
              //ihc_insert_update_transaction($lid, $insert_data['txn_id'], $insert_data);
		
		      ///////////		
		      Ihc_User_Logs::write_log( __('mellat Payment Is Verified. Refrence code is: ', 'ihc') . $Authority, 'payments');
		      Ihc_User_Logs::set_user_id(get_current_user_id());
		      Ihc_User_Logs::set_level_id($lid);
		      Ihc_User_Logs::write_log( __("mellat Payment IPN: set user id @ ", 'ihc') . get_current_user_id(), 'payments');
		      Ihc_User_Logs::write_log( __("mellat Payment IPN: Update user level expire time.", 'ihc'), 'payments');
		      ihc_update_user_level_expire($level_data, $lid, get_current_user_id());						
		      ihc_send_user_notifications(get_current_user_id(), 'payment', $lid);//send notification to user
		      ihc_send_user_notifications(get_current_user_id(), 'admin_user_payment', $lid);//send notification to admin
		      ihc_switch_role_for_user(get_current_user_id());
		
  		      ihc_set_level_trial_time_for_no_pay($lid, get_current_user_id());		
		      ihc_send_user_notifications(get_current_user_id(), 'payment', $lid);		
		      ihc_send_user_notifications(get_current_user_id(), 'admin_user_payment', $lid);//send notification to admin
		
		      do_action( 'ihc_payment_completed', get_current_user_id(), $lid );
		      ihc_switch_role_for_user(get_current_user_id());
			  //////////
		      ///////
              $debug = FALSE;
              $path = str_replace('mellat_ipn.php', '', __FILE__);
              $log_file = $path . 'mellat.log';
              $raw_post_data = file_get_contents('php://input');
              \Ihc_User_Logs::write_log( __('mellat Payment IPN: Extract data from response.', 'ihc'), 'payments');
              $raw_post_array = explode('&', $raw_post_data);
              $myPost = array();
              foreach ($raw_post_array as $keyval) {
                $keyval = explode ('=', $keyval);
                if (count($keyval) == 2)
                  $myPost[$keyval[0]] = urldecode($keyval[1]);
              }
              // read the post from PayPal system and add 'cmd'
              $req = 'cmd=_notify-validate';
              if (function_exists('get_magic_quotes_gpc')) {
                $get_magic_quotes_exists = true;
              }
              foreach ($myPost as $key => $value) {
                if ($get_magic_quotes_exists == true && get_magic_quotes_gpc() == 1) {
                  $value = urlencode(stripslashes($value));
                } else {
                  $value = urlencode($value);
                }
                $req .= "&$key=$value";
              }
              exit();
		    } else {
			   //-- در درخواست واریز وجه مشکل به وجود آمد. درخواست بازگشت وجه داده شود.
			   $client->call('bpReversalRequest', $parameters, $namespace);			
			   echo 'Error : '. $result;
			   echo '============= Ultimate Membership Pro - PAYPAL IPN ============= ';
               echo '<br/><br/>No Payments details sent. Come later';
               exit();
		    }
	      } else {
		
		     //-- وریفای به مشکل خورد٬ نمایش پیغام خطا و بازگشت زدن مبلغ
		     $client->call('bpReversalRequest', $parameters, $namespace);
		     echo 'Error : '. $result;
			 echo '============= Ultimate Membership Pro - PAYPAL IPN ============= ';
             echo '<br/><br/>No Payments details sent. Come later';
             exit();
	      }	  
        }
	}
    public function cancelSubscription( $dont_redirect_paypal=false )
    {
        if (!empty($dont_redirect_paypal)){
          return;
        }
        $sandbox = get_option('ihc_mellat_sandbox');
        $alias = get_option('ihc_mellat_email');
        $merchant_id = get_option('ihc_mellat_merchant_account_id');
        if ($merchant_id){
          $alias = $merchant_id;
        }
        if ($sandbox){
          $url = "https://www.sandbox.paypal.com/cgi-bin/webscr?cmd=_subscr-find&alias=" . urlencode($alias);
        } else {
          $url = "https://www.paypal.com/cgi-bin/webscr?cmd=_subscr-find&alias=" . urlencode($alias);
        }
        wp_redirect($url);
        exit();
    }

}