<?php
if (empty($no_load)){
	require_once '../../../wp-load.php';
	require_once 'utilities.php';
}
//require_once 'public/payir/lib/nusoap.php';
ini_set('display_errors','on');

//insert this request into debug payments table
if (get_option('ihc_debug_payments_db')){
	ihc_insert_debug_payment_log('payir', $_POST);
}

function send_payir($api, $amount, $redirect, $mobile = null, $factorNumber = null, $description = null) {
	return curl_post_payir('https://pay.ir/pg/send', [
		'api'          => $api,
		'amount'       => $amount,
		'redirect'     => $redirect,
		'mobile'       => $mobile,
		'factorNumber' => $factorNumber,
		'description'  => $description,
	]);
}

function verify_payir($api, $token) {
	return curl_post_payir('https://pay.ir/pg/verify', [
		'api' 	=> $api,
		'token' => $token,
	]);
}

function curl_post_payir($url, $params){
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_HTTPHEADER, [
		'Content-Type: application/json',
	]);
	$res = curl_exec($ch);
	curl_close($ch);

	return $res;
}

Ihc_User_Logs::write_log( __('payir Payment IPN: Start process', 'ihc'), 'payments');
$payir_email = get_option('ihc_payir_email');
$currency = get_option('ihc_currency');
$levels = get_option('ihc_levels');
$sandbox = get_option('ihc_payir_sandbox');
$r_url = get_option('ihc_payir_return_page');

$debug = FALSE;
$path = str_replace('payir_ipn.php', '', __FILE__);
$log_file = $path . 'payir.log';
$raw_post_data = file_get_contents('php://input');
Ihc_User_Logs::write_log( __('payir Payment IPN: Extract data from response.', 'ihc'), 'payments');
$raw_post_array = explode('&', $raw_post_data);
$myPost = array();
foreach ($raw_post_array as $keyval) {
	$keyval = explode ('=', $keyval);
	if (count($keyval) == 2)
		$myPost[$keyval[0]] = urldecode($keyval[1]);
}
// read the post from PayPal system and add 'cmd'
$req = 'cmd=_notify-validate';
if (function_exists('get_magic_quotes_gpc')) {
	$get_magic_quotes_exists = true;
}
foreach ($myPost as $key => $value) {
	if ($get_magic_quotes_exists == true && get_magic_quotes_gpc() == 1) {
		$value = urlencode(stripslashes($value));
	} else {
		$value = urlencode($value);
	}
	$req .= "&$key=$value";
}

$token = $_GET['token'];
$result = json_decode(verify_payir($payir_email,$token));
if(isset($result->status)){
	if($result->status == 1){
		$lid = get_option('lid'.get_current_user_id());
		$level_data = ihc_get_level_by_id($lid);
        update_option( 'lid', $lid );
		
		Ihc_User_Logs::write_log( __('payir Payment Is Verified. Refrence code is: ', 'ihc') . $Authority, 'payments');
		Ihc_User_Logs::set_user_id(get_current_user_id());
		Ihc_User_Logs::set_level_id($lid);
		Ihc_User_Logs::write_log( __("payir Payment IPN: set user id @ ", 'ihc') . get_current_user_id(), 'payments');
		Ihc_User_Logs::write_log( __("payir Payment IPN: Update user level expire time.", 'ihc'), 'payments');
		ihc_update_user_level_expire($level_data, $lid, get_current_user_id());						
		ihc_send_user_notifications(get_current_user_id(), 'payment', $lid);//send notification to user
		ihc_send_user_notifications(get_current_user_id(), 'admin_user_payment', $lid);//send notification to admin
		ihc_switch_role_for_user(get_current_user_id());
		
		ihc_set_level_trial_time_for_no_pay($lid, get_current_user_id());		
		ihc_send_user_notifications(get_current_user_id(), 'payment', $lid);		
		ihc_send_user_notifications(get_current_user_id(), 'admin_user_payment', $lid);//send notification to admin
		
		do_action( 'ihc_payment_completed', get_current_user_id(), $lid );
		ihc_switch_role_for_user(get_current_user_id());
		
		$price = get_option('price'.get_current_user_id());				
		$ipn_data = array();
		$ipn_data['amount'] = $price;
		$ipn_data['uid'] = get_current_user_id();
		$ipn_data['lid'] = $lid;
		$ipn_data['payment_status'] = 'Completed';
		//$ipn_data['txn_id'] = "txn_" . time() . "_" . get_current_user_id() . "_" . $lid;
		$ipn_data['ihc_payment_type'] = 'payir';
		//$ipn_data['ihc_authority_payir'] = $Authority;
		$ipn_data['currency'] = '$';
		ihc_insert_update_transaction(get_current_user_id(), "txn_" . time() . "_" . get_current_user_id(), $ipn_data);
		
		update_option( 'lid7', '1' );
        delete_option('lid'.get_current_user_id());
        delete_option('price'.get_current_user_id());
        update_option( 'final', 'payir' );
         delete_option('payir'.get_current_user_id());
		//header('HTTP/1.0 200 OK');
		$r_url = get_option('r_url'.get_current_user_id());
		delete_option('payir'.get_current_user_id());
		delete_option('r_url'.get_current_user_id());
		Header('Location: '.$r_url);
	} else {
		//Ihc_User_Logs::write_log( __("PayPal Payment IPN: cURL request is Invaild.", 'ihc'), 'payments');
		///problems with connection
		$levelid = get_option('lid'.get_current_user_id());
		Ihc_User_Logs::write_log( __('payir Payment IPN: request is Invaild. Error code is: ', 'ihc') . $result['Status'], 'payments');
		
		if (!function_exists('ihc_is_user_level_expired')){
			require_once IHC_PATH . 'public/functions.php';
		}
		$expired = ihc_is_user_level_expired(get_current_user_id(), $levelid, FALSE, TRUE);
		if ($expired){
		//it's expired and we must delete user - level relationship
			Ihc_User_Logs::write_log( __("payir Payment IPN: Delete user level.", 'ihc'), 'payments');
			ihc_delete_user_level_relation($levelid, get_current_user_id());
		}
		if ($debug){
			error_log(date('[Y-m-d H:i e] '). "Invalid IPN: $req" . PHP_EOL, 3, $log_file);
		}
		echo date('[Y-m-d H:i e] '). "Invalid IPN: $req";
		 delete_option('payir'.get_current_user_id());
	}
} else {
	if($_GET['status'] == 0){
		delete_option('payir'.get_current_user_id());
	    echo '============= Ultimate Membership Pro - PAYPAL IPN ============= ';
	    echo '<br/><br/>No Payments details sent. Come later';
	    sleep(10);
	    $r_url = get_option('r_url'.get_current_user_id());
        Header('Location: '.$r_url);
	    exit();
	}
}